if(!isObject(ReserveGUI))
	exec("./ReserveGUI.gui");

function ReserveGUI_IDBoxEnter()
{
	commandToServer('setReserveID',ReserveGUI_IDBox.getValue(),1);
	ReserveGUI_AddID.setVisible(0);
	ReserveGUI_IDBox.setValue("");
}

function ReserveGUI_AddIDClick()
{
	ReserveGUI_AddID.setVisible(1);
	ReserveGUI_IDBox.makeFirstResponder(1);
	ReserveGUI.pushToBack(ReserveGUI_AddID);
}

function ReserveGUI_SlotBoxEnter()
{
	commandToServer('updateSlotSettings',ReserveGUI_SlotBox.getValue(),1,3);
	ReserveGUI_Slots.setVisible(0);
	ReserveGUI_SlotBox.setValue("");
}

function ReserveGUI_SlotsClick()
{
	ReserveGUI_Slots.setVisible(1);
	ReserveGUI_SlotBox.makeFirstResponder(1);
	ReserveGUI.pushToBack(ReserveGUI_Slots);
}

function ReserveGUI_AddClick()
{
	%id = ReserveGUI_PlayerList.getSelectedID();
	commandToServer('setReserveID',%id,1);
}

function ReserveGUI_RemoveClick()
{
	%id = ReserveGUI_ReserveList.getSelectedID();
	commandToServer('setReserveID',%id,0);
}

function clientCmdUpdateReserve(%val,%id)
{
	if(%val == 0)
		ReserveGUI_ReserveList.clear();
	else
		ReserveGUI_ReserveList.addRow(%id,%id);
}

function ReserveGUI::onWake(%this)
{
	ReserveGUI_Slots.setVisible(0);
	ReserveGUI_SlotBox.setValue("");
	ReserveGUI_AddID.setVisible(0);
	ReserveGUI_IDBox.setValue("");
	ReserveGUI_PlayerList.clear();
	for(%i=0;%i<NPL_List.rowCount();%i++)
	{
		%row = getFields(NPL_List.getRowText(%i),0,1) TAB getField(NPL_List.getRowText(%i),3);
		%id = NPL_List.getRowId(%i);
		ReserveGUI_PlayerList.addRow(getField(NPL_List.getRowText(%i),3),%row);
	}
}

function toggleReserveWindow(%val)
{
	if(%val)
		if(ReserveGUI.isAwake())
			canvas.popdialog(ReserveGUI);
		else
			canvas.pushdialog(ReserveGUI);
}

package ReserveClient
{
	function disconnectedCleanup()
	{
		Parent::disconnectedCleanup();
		ReserveGUI_ReserveList.clear();
		ReserveGUI_PlayerList.clear();
	}
};

activatePackage(ReserveClient);

//Stolen from Randy
function AddBind(%division, %name, %command)
{
	for(%i=0;%i<$remapCount;%i++)
	{
		if($remapDivision[%i] $= %division)
		{
			%foundDiv = 1;
			continue;
		}
		if(%foundDiv && $remapDivision[%i] !$= "")
		{
			%position = %i;
			break;
		}
	}
	if(!%foundDiv)
	{
		error("Division not found: " @ %division);
		return;
	}
	if(!%position)
	{
		$remapName[$remapCount] = %name;
		$remapCmd[$remapCount] = %command;
		$remapCount++;
		return;
	}
	for(%i=$remapCount;%i>%position;%i--)
	{
		$remapDivision[%i] = $remapDivision[%i - 1];
		$remapName[%i] = $remapName[%i - 1];
		$remapCmd[%i] = $remapCmd[%i - 1];
	}
	$remapDivision[%position] = "";
	$remapName[%position] = %name;
	$remapCmd[%position] = %command;
	$remapCount++;
}
if(!$addedReserveBind)
{
	AddBind("Gui","Open Reserve Window","toggleReserveWindow");
	$addedReserveBind = true;
}