//I'll do something with these 3 later.
$Pref::Server::ReserveAdminList = 3;
$Pref::Server::ReserveAdminLevel = 3;
$Pref::Server::NoSlotNotification = 1;

package ReserveSlots
{
	function GameConnection::autoAdminCheck(%this)
	{
		//Code from Truce's Admin Controls Manager
		//This is to get the host's client.
		%this.isHost=0;
		if(%this.isLocalConnection()||%this.bl_id==getNumKeyID())
			%this.isHost=1;
		//End of Truce's code

		%normalPlayerCount = ClientGroup.getNormalCount();
		%normalSlots = $Pref::Server::MaxPlayers-$Pref::Server::ReserveSlots-%normalPlayerCount+1;
		if(%normalSlots <= 0 && %this.SearchForReserve() != 1)
		{
			%name = %this.netName;
			%this.delete("There are no more available slots left. Please wait till there are less than " @ $Pref::Server::MaxPlayers-$Pref::Server::ReserveSlots @ " players in the game.");
			if($Pref::Server::NoSlotNotification == 1)
				messageAll('','\c2%1 could not join the game due to unavailable slots.',%name);
			return;
		}
		commandToClient(%this,'UpdateReserve',0);
		for(%x=1;%x<=$Pref::Server::ReserveSlotCount;%x++)
			commandToClient(%this,'UpdateReserve',1,$Pref::Server::ReserveSlot[%x]);
		return Parent::autoAdminCheck(%this);
	}
	
	function GameConnection::SearchForReserve(%this)
	{
		for(%x=1;%x<=$Pref::Server::ReserveSlotCount;%x++)
			if($Pref::Server::ReserveSlot[%x] == %this.BL_ID)
				return 1;
		return 0;
	}
	
	function SimGroup::getNormalCount(%this)
	{
		if(%this.getName() !$= "ClientGroup")
			return;
		%c=0;
		for(%s=0;%s<%this.getCount();%s++)
		{
			%cl = %this.getObject(%s);
			if(%cl.searchForReserve() != 1)
				%c++;
		}
		return %c;
	}
	function AdminlevelMessageClients(%adminlevel,%message)
	{
		%this = ClientGroup;
		for(%s=0;%s<%this.getCount();%s++)
		{
			%cl = %this.getObject(%s);
			switch$ (%adminlevel)
			{
				case 0:
					messageClient(%cl,'','%1',%message);
				case 1:
					if(%cl.isAdmin)
						messageClient(%cl,'','%1',%message);
				case 2:
					if(%cl.isSuperAdmin)
						messageClient(%cl,'','%1',%message);
				case 3:
					if(%cl.isHost)
					{
						messageClient(%cl,'','%1',%message);
						%foundhost = 1;
					}
			}
		}
		if(%adminLevel == 3)
			echo(%message);
	}
	function serverCmdUpdateSlotSettings(%client,%count,%NSNote,%AdminLevel)
	{
		//if((%client.isSuperAdmin == 1 && $Pref::Server::ReserveAdminLevel == 2) || (%client.isAdmin == 1 && $Pref::Server::ReserveAdminLevel == 1) || (%client.isHost && $Pref::Server::ReserveAdminLevel == 3))
		if(%client.isHost)
		{
			$Pref::Server::ReserveSlots = %count;
			//$Pref::Server::NoSlotNotification = %NSNote;
			//AdminlevelMessageClients($Pref::Server::ReserveAdminLevel,"\c3" @ %client.netName @ " has updated the reserve settings.");
			AdminlevelMessageClients($Pref::Server::ReserveAdminLevel,"Slots: " @ %count);
			//AdminlevelMessageClients($Pref::Server::ReserveAdminLevel,"No slot notification: " @ %NSNote);
		}
		if(%client.isHost == 1)
		{
			//AdminlevelMessageClients($Pref::Server::ReserveAdminLevel,"Admin level for changing settings: " @ %adminLevel);
			//$Pref::Server::ReserveAdminLevel = %AdminLevel;
		}
	}
	function serverCmdSetReserveID(%client,%id,%value)
	{
		//if(((%client.isSuperAdmin == 1 && $Pref::Server::ReserveAdminList == 2) || (%client.isAdmin == 1 && $Pref::Server::ReserveAdminList == 1) || (%client.isHost && $Pref::Server::ReserveAdminList == 3)) && (%value == 0 || %value == 1))
		if(%client.isHost && %value == 1)
			addReserveSlotToList(%id);
		else if(%client.isHost)
			removeReserveSlotFromList(%id);
	}
	function removeReserveSlotFromList(%id)
	{
		for(%x=1;%x<=$Pref::Server::ReserveSlotCount;%x++)
		{
			if($Pref::Server::ReserveSlot[%x] == %id)
			{
				for(%y=%x;%y<=$Pref::Server::ReserveSlotCount;%y++)
					$Pref::Server::ReserveSlot[%y] = $Pref::Server::ReserveSlot[%y+1];
				$Pref::Server::ReserveSlotCount--;
				updateSlotList();
				return;
			}
		}
	}
	function addReserveSlotToList(%id)
	{
		for(%x=1;%x<=$Pref::Server::ReserveSlotCount;%x++)
			if($Pref::Server::ReserveSlot[%x] == %id)
				return;
		$Pref::Server::ReserveSlot[$Pref::Server::ReserveSlotCount++] = %id;
		updateSlotList();
	}
	function updateSlotList()
	{
		for(%y=0;%y<ClientGroup.getCount();%y++)
		{
			%cl = ClientGroup.getObject(%y);
			commandToClient(%cl,'UpdateReserve',0);
			for(%x=1;%x<=$Pref::Server::ReserveSlotCount;%x++)
				commandToClient(%cl,'UpdateReserve',1,$Pref::Server::ReserveSlot[%x]);
		}
	}
};

activatePackage(ReserveSlots);